/*=====================================================================================
Cкрипт оставляет в выделении объекты у которых выделены все точки

© polygraphus, 2010
polygraphus@polygraphus.com
=====================================================================================*/
if ( app.documents.length > 0 ) { // если есть открытые документы
	var selectedPaths = app.selection; // выделенные объекты
	var numSelectedPaths = selectedPaths.length; // количество выделенных объектов
	for ( var i = numSelectedPaths - 1; i >=0 ; i-- ) { // перебираем с конца все выделенные пути
		SelectAllParent(selectedPaths[i]); // берем старейший родительский объект до объекта Layer
	}
}
//=====================================================================================
function  SelectAllPoints(pi){ // выделяем все точки данного PathItem
	if(pi.selectedPathPoints.length != pi.pathPoints.length) { // если выделены не все точки
		for(var i = 0; i < pi.pathPoints.length; i++) {
			pi.pathPoints[i].selected = PathPointSelection.NOSELECTION;
		}
	} else {
		if(NotAllPointsSelected(pi)) { // Если не все выделенные точки имеют статус ANCHORPOINT
			for(var i = 0; i < pi.pathPoints.length; i++) {
				pi.pathPoints[i].selected = PathPointSelection.NOSELECTION;
			}
		}
	}
}
//=====================================================================================
function  NotAllPointsSelected(p){ 
	var result = false;
	for(var i = 0; i < p.pathPoints.length; i++) {
		if(p.pathPoints[i].selected != PathPointSelection.ANCHORPOINT) {
			result = true;
			break;
		}
	}
	return result;
}
//=====================================================================================
function  SelectAllParent(obj) { // выделяем все точки объекта и его родительских объектов
	var oldest = obj;
	while(oldest.parent.constructor.name != 'Layer') {
		oldest = oldest.parent;
	}
	if (oldest.constructor.name == 'PathItem') { // если это просто PathItem
		SelectAllPoints(oldest); // выделяем все точки
	} else {
		allPI = oldest.pathItems;
		for(j = 0; j < allPI.length; j++){
			SelectAllPoints(allPI[j]); // выделяем все точки
		}
		if (oldest.constructor.name == 'GroupItem') {
			allG = oldest.groupItems;
			for(m = 0; m < allG.length; m++){
				allGPI = allG[m].pathItems;
				for(k = 0; k < allGPI.length; k++){
					SelectAllPoints(allGPI[k]); // выделяем все точки
				}
				allCPI = allG[m].compoundPathItems;
				for(k = 0; k < allCPI.length; k++){
					for(l=0; l < allCPI[k].pathItems.length; l++){
						SelectAllPoints(allCPI[k].pathItems[l]); // выделяем все точки
					}
				}
			}
			
			allGPI = oldest.pathItems;
			for(k = 0; k < allGPI.length; k++){
				SelectAllPoints(allGPI[k]); // выделяем все точки
			}
			allCPI = oldest.compoundPathItems;
			for(k = 0; k < allCPI.length; k++){
				for(l=0; l < allCPI[k].pathItems.length; l++){
					SelectAllPoints(allCPI[k].pathItems[l]); // выделяем все точки
				}
			}
		}
	}
}